unit Collections;
	interface		
		type
			(* Linked List *)
			ListRef = ^List;
			List = record
				current : Pointer; (* Some object *)
				next : ListRef;
				end;

			(* Array List Object *)
			ArrayListRef = ^ArrayList;
			ArrayList = object
				first : ListRef;
				last : ListRef;
				constructor Init;
				destructor Done;
				procedure Add(el : Pointer);
				function Empty : boolean;
				function Head : Pointer;
				function Tail : ArrayListRef;
			end;

	implementation
		constructor ArrayList.Init;
			begin
				first := nil;
				last := nil;
			end;

		(* Free all elements from the linked list *)
		procedure DisposeAll(list : ListRef);
			var next : ListRef;
			begin
				if list <> nil then begin
					next := list^.next;
				  Dispose(list); (* Free memory *)
					DisposeAll(next);
				end
			end;

		destructor ArrayList.Done;
			begin
				last := nil;
				DisposeAll(first);
				first := nil;
			end;

		(* Add element to the list *)
		procedure ArrayList.Add(el : Pointer);
			var item : ListRef;
			begin
				New(item);
				item^.current := el;
				
				if first = nil then
					first := item
				else
					last^.next := item;
				
				last := item;				
			end;

		(* Is the list empty? *)
		function ArrayList.Empty : boolean;
			begin
				Empty := first = nil;
			end;

		(* First element in list *)
		function ArrayList.Head : Pointer;
			begin
				if Empty then
					Head := nil
				else
					Head := first^.current				
			end;

		(* Rest of the list *)
		function ArrayList.Tail : ArrayListRef;
			var list : ArrayListRef;
			begin
				New(list, Init);

				list^.first := first^.next;
				list^.last := last;
				Tail := list;
			end;
	end.
