program RecordStore;
	uses Collections; (* Import the type ArrayList *)

	type
		RecordRef = ^RecordObject;

		RecordObject = object
			title : string;
			artist : string;
			constructor Create(titleInput, artistInput : string);
			procedure Print;
		end;

	var records : ArrayListRef;

	(* RecordObject instance procedures *)
	constructor RecordObject.Create(titleInput, artistInput : string);
		begin
			title := titleInput;
			artist := artistInput;
		end;

	procedure RecordObject.Print;
		begin
				Write(title);
				Write(' - ');
				Writeln(artist);
		end;

	(* Main program *)
	procedure Add(title, artist : string);
		var my_record : RecordRef;
		begin
			New(my_record, Create(title, artist));
			records^.Add(my_record);
		end;

	(* Go through list and print every record *)
	procedure Print(list : ArrayListRef);
		var 
			tail : ArrayListRef;
			current : RecordRef;
		begin
			if not list^.Empty then	begin
				current := list^.Head;
				current^.Print; (* Print record *)

				tail := list^.Tail;
				Print(tail);
				Dispose(tail); (* Disposes the tail, not the records in the list *)
			end;
		end;

	begin
		(* Create new list of records *)
		New(records, Init);

		Add('Dark side of the moon', 'Pink Floyd');
		Add('The Rise and Fall of Ziggy Stardust and the Spiders from Mars', 'David Bowie');
		Add('L.A. Woman', 'The Doors');

		Print(records);
		Dispose(records, Done);
	end.
